; Source code assembled with GoAsm.Exe Version 0.56.4e

#include "Mbox.inc"

.data

capt        db "Hello!",0
msg         db 'Customized message box',0
msg2        db 'Message box test',0
ButtonText  db 'Click here',0
bclass      db 'Button',0
pOldProc    dd ?

.code

start:
    
    invoke  CustMsgBox,0,ADDR msg,ADDR capt,ADDR ButtonText
    invoke  ExitProcess,0
    
CustMsgBox  FRAME handle,message,caption,button

USES esi

LOCAL rc:RECT
LOCAL ThreadID
LOCAL hWnd
LOCAL hThread
LOCAL buffer[16]:B

    invoke  CreateThread,0,0,ADDR ThreadProc,ADDR caption,0,ADDR ThreadID
    mov     [hThread],eax
: 
    invoke  EnumWindows,ADDR EnumWndProc,ADDR ThreadID
    invoke  GetWindowText,[hWnd],ADDR buffer,10
    invoke  lstrcmp,ADDR buffer,[caption]
    test    eax,eax
    jnz     <
    invoke  FindWindowEx,[hWnd],0,ADDR bclass,0
    invoke  SetWindowText,eax,[button]
    invoke  GetWindowRect,[hWnd],ADDR rc
    mov     ecx,[rc.right]
    sub     ecx,[rc.left]
    mov     edx,[rc.bottom]
    sub     edx,[rc.top]
    add     edx,20
    invoke  SetWindowPos,[hWnd],0,0,0,ecx,edx,SWP_NOACTIVATE or SWP_NOMOVE
    invoke  GetModuleHandle,0
    invoke  LoadMenu,eax,IDM_MENU
    invoke  SetMenu,[hWnd],eax
    invoke  SetWindowLong,[hWnd],GWL_WNDPROC,ADDR MsgboxProc
    mov     [pOldProc],eax
    invoke  WaitForSingleObject,[hThread],INFINITE
    invoke  CloseHandle,[hThread]
    ret

ENDF

ThreadProc  FRAME pParams
    
    mov     eax,[pParams]
    invoke  MessageBox,[eax-8],[eax-4],[eax],MB_OK
    ret
    
ENDF

EnumWndProc FRAME hWnd,lParam
    
    LOCAL   pid
    
    invoke  GetWindowThreadProcessId,[hWnd],ADDR pid
    mov     edx,[lParam]
    cmp     eax,[edx]
    jne     >
    push    [hWnd]
    pop     [edx-4]            ; get the handle of the window
    xor     eax,eax            ; displaying the message box
    ret
:
    mov     eax,TRUE
    ret

ENDF

MsgboxProc  FRAME hWnd,uMsg,wParam,lParam
    
    cmp     d[uMsg],WM_COMMAND
    jne     >CallWndProc

    
        cmp     d[wParam],IDB_EXIT
        jne     >
        invoke  SendMessage,[hWnd],WM_CLOSE,0,0
        jmp     >CallWndProc
:    
        cmp     d[wParam],IDB_ABOUT
        jne     >CallWndProc

        invoke  MessageBox,0,ADDR msg2,ADDR capt,MB_OK

CallWndProc:
    
    invoke  CallWindowProc,[pOldProc],[hWnd],[uMsg],[wParam],[lParam]
    ret
    
ENDF
    